import 'package:article_flutter_riverpod/app.dart';
import 'package:article_flutter_riverpod/article_02/01_consumer_example.dart';
import 'package:article_flutter_riverpod/article_02/04_parent_example.dart';
import 'package:article_flutter_riverpod/article_02/03_stateful_example.dart';
import 'package:article_flutter_riverpod/article_02/02_stateless_example.dart';
import 'package:article_flutter_riverpod/example.dart';
import 'package:article_flutter_riverpod/presentation/01_introduction_example.dart' as introduction_example;
import 'package:article_flutter_riverpod/presentation/02_provider_example.dart' as provider_example;
import 'package:article_flutter_riverpod/presentation/03_select_example.dart' as select_example;
import 'package:article_flutter_riverpod/presentation/04_stateful_example.dart' as stateful_example;
import 'package:article_flutter_riverpod/presentation/05_state_provider_example.dart' as state_provider_example;
import 'package:article_flutter_riverpod/presentation/07_overrides_example.dart' as overrides_example;
import 'package:article_flutter_riverpod/presentation/08_future_provider_example.dart' as future_provider_example;
import 'package:article_flutter_riverpod/presentation/09_async_value_example.dart' as async_value_example;
import 'package:flutter/material.dart';

final _groups = [
  ExampleGroup(
    title: 'Article 01',
    icon: Icons.filter_1,
    path: '/article_01',
    examples: [
      Example(
        title: 'Consumer',
        icon: Icons.eco,
        path: 'consumer',
        builder: (_) => const ConsumerExample(),
      ),
      Example(
        title: 'Stateless',
        icon: Icons.remove_circle_outline,
        path: 'stateless',
        builder: (_) => const StatelessExample(),
      ),
      Example(
        title: 'Stateful',
        icon: Icons.add_circle_outline,
        path: 'stateful',
        builder: (_) => const StatefulExample(),
      ),
      Example(
        title: 'Parent ProviderScope',
        icon: Icons.child_care,
        path: 'parent-providerscope',
        builder: (_) => const ParentExample(),
      ),
    ],
  ),
  ExampleGroup(
    title: 'Presentation',
    icon: Icons.screenshot_monitor,
    path: '/presentation',
    examples: [
      Example(
        title: 'Introduction',
        icon: Icons.eco,
        path: 'todo-introduction',
        builder: (_) => const introduction_example.TodoExample(),
        isScrollable: false,
      ),
      Example(
        title: 'Provider',
        icon: Icons.arrow_forward,
        path: 'todo-provider',
        builder: (_) => const provider_example.TodoExample(),
        isScrollable: false,
      ),
      Example(
        title: 'Select',
        icon: Icons.filter_alt,
        path: 'todo-select',
        builder: (_) => const select_example.TodoExample(),
        isScrollable: false,
      ),
      Example(
        title: 'Stateful',
        icon: Icons.add_circle_outline,
        path: 'todo-stateful',
        builder: (_) => const stateful_example.TodoExample(),
        isScrollable: false,
      ),
      Example(
        title: 'StateProvider',
        icon: Icons.folder_open,
        path: 'todo-state-provider',
        builder: (_) => const state_provider_example.TodoExample(),
        isScrollable: false,
      ),
      Example(
        title: 'Overrides',
        icon: Icons.filter,
        path: 'todo-overrides',
        builder: (_) => const overrides_example.TodoExample(),
        isScrollable: false,
      ),
      Example(
        title: 'FutureProvider',
        icon: Icons.refresh,
        path: 'todo-future-provider',
        builder: (_) => const future_provider_example.TodoExample(),
        isScrollable: false,
      ),
      Example(
        title: 'AsyncValue',
        icon: Icons.update,
        path: 'todo-async-value',
        builder: (_) => const async_value_example.TodoAsyncValueExample(),
        isScrollable: false,
      ),
    ],
  ),
];

void main() {
  runApp(App(_groups));
}
