import 'package:article_flutter_riverpod/example.dart';
import 'package:flutter/material.dart';
import 'package:go_router/go_router.dart';

class ExampleGroupScreen extends StatelessWidget {
  const ExampleGroupScreen(
    this.group, {
    Key? key,
  }) : super(key: key);

  final ExampleGroup group;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(group.title),
      ),
      body: ListView.builder(
        itemBuilder: (_, index) => ExampleListItem(
          group,
          group.examples[index],
        ),
        itemCount: group.examples.length,
      ),
    );
  }
}

class ExampleListItem extends StatelessWidget {
  const ExampleListItem(
    this.group,
    this.example, {
    Key? key,
  }) : super(key: key);

  final ExampleGroup group;
  final Example example;

  @override
  Widget build(BuildContext context) {
    return ListTile(
      leading: Icon(
        example.icon,
        color: Theme.of(context).primaryColor,
      ),
      title: Text(
        example.title,
        overflow: TextOverflow.ellipsis,
      ),
      trailing: const Icon(Icons.chevron_right),
      onTap: () => _onItemTapped(context, example),
    );
  }

  void _onItemTapped(BuildContext context, Example example) {
    context.go("${group.path}/${example.path}");
  }
}
